function get_automation_scripts()
	local pwd = get_session_state("pwd") -- inserting pwd, boo!
	local f = {}

	function f.coffee_pixie_stick()
		inform "using coffee pixie stick"
		get_page("/town_wrong.php")
		get_page("/arcade.php", { action = "skeeball", pwd = pwd })
		post_page("/arcade.php", { action = "redeem", whichitem = tostring(get_itemid("coffee pixie stick")), quantity = tostring(1) })
		if have("coffee pixie stick") then
			local a = advs()
			local result, resulturl = use_item("coffee pixie stick")
			if advs() > a then
				local did_action = true
				return result, resulturl, did_action
			else
				error("Tried to use pixie stick but didn't gain any adventures")
			end
		else
			error("Didn't get coffee pixie stick")
		end
	end

	function f.ensure_worthless_item()
		if not (have("worthless trinket") or have("worthless gewgaw") or have("worthless knick-knack")) then
			inform "get worthless item"
			if not have("chewing gum on a string") then
				buy_item("chewing gum on a string", "m")
				if not have("chewing gum on a string") then
					error "Couldn't buy chewing gum"
				end
			end
			result, resulturl = use_item("chewing gum on a string")
			if result:match("You acquire") then
				f.ensure_worthless_item()
			else
				error "Failed to use chewing gum"
			end
		end
		return result, resulturl, did_action
	end

	local function feed_slimeling()
		local function feed(name)
			print("feeding", name)
			return post_page("/familiarbinger.php", { action = "binge", pwd = pwd, qty = 1, whichitem = get_itemid(name) })
		end
		local feed_items = {
			"snapdragon pistil", "elephant stinger",
			"spooky stick",
			"diamond-studded cane", "leather mask", "flaming crutch", "infernal insoles", "infernal fife",
			"Knob Goblin scimitar", "Knob Goblin pants", "Knob Goblin tongs", "viking helmet",
			"spiked femur", "lihc face", "rusty grave robbing shovel", "bone flute",
			"knob bugle",
			"cornuthaum", "vorpal blade", "magic whistle", "ninja hot pants",
			"ASCII shirt",
			"crowbarrr", "Jolly Roger charrrm bracelet",
			"glowing red eye", "magilaser blastercannon", "titanium assault umbrella", "armgun", "ridiculously huge sword", "ocarina of space", "amulet of extreme plot significance",
			"rave whistle",
			"black helmet", "black sword", "black greaves",
			"leotarrrd", "grassy cutlass",
			"batblade",
			"antique helmet", "antique spear", "antique shield", "antique greaves",
			"broken sword",
		}
		local feed_except_one = {
			{ "leather chaps", },
			{ "wonderwall shield", },
			{ "black shield", },
			{ "snake shield", },
			{ "oversized pizza cutter", "huge spoon", },
			{ "hors d'oeuvre tray", },
			{ "hot plate", "coffin lid", },
			{ "tap shoes", },
			{ "worn tophat", "wolf mask", "cornuthaum", },
			{ "dead guy's watch", },
			{ "disturbing fanfic", },
			{ "4-dimensional guitar", },
			{ "mesh cap", },
		}
		for _, i in pairs(feed_items) do
			if have(i) then
				feed(i)
			end
		end
		for _, tbl in pairs(feed_except_one) do
			local found = false
			for _, i in pairs(tbl) do
				if count(i) > 1 then
					if count(i) > 10 then
						error("More than 10 of " .. i .. " when feeding slimeling")
					end
					feed(i)
				end
--~ 				if found and have(i) then
--~ 					feed(i)
--~ 				elseif have(i) then
--~ 					found = true
--~ 					if count(i) > 1 then
--~ 						feed(i)
--~ 					end
--~ 				end
			end
		end
	end

	local familiar_data = {
		["Slimeling"] = { id = 112, f = feed_slimeling, mpregen = true },
		["Mini-Hipster"] = { id = 136, mpregen = true, familiarequip = "fixed-gear bicycle" },
		["Rogue Program"] = { id = 135, mpregen = true },
		["Jumpsuited Hound Dog"] = { id = 69 },
		["Frumious Bandersnatch"] = { id = 105 },
		["Rock Lobster"] = { id = 114, mpregen = true },
		["Knob Goblin Organ Grinder"] = { id = 139 },
		["Midget Clownfish"] = { id = 106, mpregen = true },
		["Stocking Mimic"] = { id = 120, mpregen = true, familiarequip = "bag of many confections" },
		["Hobo Monkey"] = { id = 89 },
		["He-Boulder"] = { id = 113, mpregen = true },
		["Reassembled Blackbird"] = { id = 59 },
	}

	function f.set_familiar(famname)
		local d = familiar_data[famname]
		if d then
			if d.id ~= familiarid() then
				switch_familiarid(d.id)
			end
			if d.f then
				d.f()
			end
		elseif type(famname) == "number" then
			print("warning: switching to fam", famname, "by number")
			if famname ~= familiarid() then
				switch_familiarid(famname)
			end
		else
			error("Unknown familiar: " .. famname)
		end
	end

	function f.burn_mp(downto, hundreds)
		if not hundreds then
			hundreds = 50
		end
		if not downto then
			error "No downto for burn_mp"
		end
		local distance = 30
		if level() >= 8 then
			distance = 50
		end
		distance = distance + maxmp() / 5
		if maxmp() > 50 and (maxmp() - mp()) < distance and mp() > downto and hundreds < 1000 then
			local toburn = mp() - downto
-- 			print("burn mp", toburn, hundreds, "level", level())
			if level() < 8 and (buffturns("The Magical Mojomuscular Melody") < 50 or toburn < 10) then
				cast_buff(6004, math.floor(toburn / 5)) -- madrigal
				cast_buff(6007, math.floor(toburn / 5)) -- mojo
			elseif buffturns("Leash of Linguini") < hundreds and toburn >= 12 then
				cast_buff(3010, math.floor(toburn / 12)) -- leash of linguini
			elseif buffturns("Empathy") < hundreds and toburn >= 15 then
				cast_buff(2009, math.floor(toburn / 15)) -- empathy of the newt
			elseif level() >= 8 and buffturns("Fat Leon's Phat Loot Lyric") < hundreds and toburn >= 11 then
				cast_buff(6010, math.floor(toburn / 11)) -- phat loot
			elseif level() >= 8 and level() < 13 and buffturns("Ur-Kel's Aria of Annoyance") < hundreds and toburn >= 30 then
				cast_buff(6017, math.floor(toburn / 30)) -- aria
			elseif buffturns("Springy Fusilli") < hundreds and toburn >= 10 then
				cast_buff(3015, math.floor(toburn / 10)) -- springy fusilli
			elseif buffturns("Ghostly Shell") < hundreds and toburn >= 6 then
				cast_buff(2007, math.floor(toburn / 6)) -- ghostly shell
			elseif buffturns("Astral Shell") < hundreds and toburn >= 10 then
				cast_buff(2012, math.floor(toburn / 10)) -- astral shell
			elseif level() >= 8 and buffturns("A Few Extra Pounds") < hundreds and toburn >= 10 then
				cast_buff(1024, math.floor(toburn / 10)) -- holiday weight gain
			else
				return f.burn_mp(downto, hundreds + 100)
			end
		end
	end

	function f.trade_for_clover()
		if not have("hermit permit") then
			inform "buying hermit permit"
			buy_item("hermit permit", "m")
			if not have("hermit permit") then
				error "Failed to buy hermit permit"
			end
		end
		f.ensure_worthless_item()
		local hermitpt = get_page("/hermit.php")
		if hermitpt:contains("left in stock") then
			inform "trading for clover"
			local clovers = count("disassembled clover")
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("ten-leaf clover"), quantity = 1 })
			use_item("ten-leaf clover")
			if count("disassembled clover") > clovers then
				did_action = true
			end
		end
		return did_action
	end

	function f.use_and_sell_items()
		local use_items = {
			"chest of the Bonerdagon",
			"small box", "large box", "dead mimic",
			"canopic jar",
			"old coin purse", "old leather wallet",
			"Warm Subject gift certificate",
			"black pension check",
			"fat wallet",
			"ancient vinyl coin purse",
			"briefcase",
		}

		for _, w in pairs(use_items) do
			if have(w) then
				if count(w) >= 10 then
					error("Got 10+ of " .. w)
				end
				use_item(w)
			end
		end

		local sell_items = {
			"magicalness-in-a-can", "concentrated magicalness pill",
			"moxie weed", "giant moxie weed",
			"strongness elixir", "enchanted barbell",
			"bit-o-cactus", "handful of moss", "suntan lotion of moxiousness", "ancient protein powder",
			"Imp Ale", "hot katana blade", "demon skin",
			"meat paste", "meat stack", "dense meat stack",
			"gator skin", "decaying goldfish liver", "sewer nuggets", "bottle of sewage schnapps",
			"drab sonata",
			"cocoa eggshell fragment",
			"towel",
			"fat stacks of cash",
			"rat appendix", "batgut", "catgut",
			"ghuol egg", "ghuol guolash", "cranberries",
			"bowl of cottage cheese",
			"ballroom blintz", "royal jelly", "unidentified jerky", "mind flayer corpse",
			"procrastination potion",
			"grouchy restless spirit",
			"cat appendix",
			"baby killer bee",
		}
		local sell_except_one = {
			"fancy bath salts",
			"leathery bat skin", "leathery cat skin", "leathery rat skin",
			"photoprotoneutron torpedo",
			"Angry Farmer candy",
		}
		for _, s in pairs(sell_items) do
			if have(s) then
				if count(s) >= 10 then
					error("Got 10+ of " .. s)
				end
				sell_itemid(get_itemid(s), "1")
			end
		end
		for _, s in pairs(sell_except_one) do
			if count(s) >= 2 then
				if count(s) >= 10 then
					error("Got 10+ of " .. s)
				end
				sell_itemid(get_itemid(s), "1")
			end
		end
	end

	function f.heal_up()
		if hp() / maxhp() < 0.8 and ((maxhp() - hp() >= 30) or maxhp() < 50) then
			ensure_mp(12)
			local oldhp = hp()
			cast_buff(5011) -- disco power nap
			if hp() > oldhp then
				print("restore hp", oldhp, "to", hp(), "max is", maxhp())
				f.heal_up()
			else
				error "Casting Disco Power Nap didn't increase HP!"
			end
		end
	end

	function f.ensure_mp(amount)
		if maxmp() < amount then
			error("Maxmp < " .. amount .. " when trying to ensure MP")
		end
		if mp() < amount then
			local need = amount - mp()
			if need > 100 then
				error "trying to restore more than 100 mp"
			end
			local restore_items = {
				["natural fennel soda"] = 120,
				["carbonated soy milk"] = 80,
				["bottle of Monsieur Bubble"] = 60,
				["carbonated water lily"] = 65,
				["Knob Goblin superseltzer"] = 30,
				["sugar shard"] = 10,
				["ancient Magi-Wipes"] = 55,
				["phonics down"] = 50,
				["honey-dipped locust"] = 35,
				["magical mystery juice"] = 1.5 * level() + 6,
				["tonic water"] = 45,
				["black cherry soda"] = 11,
				["Knob Goblin seltzer"] = 12,
			}
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit < maxmp()) then
					use_item(name)
					return ensure_mp(amount)
				end
			end
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit * 0.75 < maxmp()) then
					use_item(name)
					return ensure_mp(amount)
				end
			end
			for name, limit in pairs(restore_items) do
				if have(name) and (mp() + limit * 0.5 < maxmp()) then
					use_item(name)
					return ensure_mp(amount)
				end
			end
			if get_mainstat() == "Mysticality" and level() >= 4 then
				buy_item("magical mystery juice", "2")
				if have("magical mystery juice") then
					return ensure_mp(amount)
				else
					error "couldn't buy mmj as lvl 4+ myst class"
				end
			elseif have("Cobb's Knob lab key") and ((have("Knob Goblin elite helm") and have("Knob Goblin elite polearm") and have("Knob Goblin elite pants")) or level() >= 8) then
				buy_item("Knob Goblin seltzer", "k", 5)
				if have("Knob Goblin seltzer") then
					return ensure_mp(amount)
				else
					error "Couldn't buy kgs"
				end
			elseif level() >= 8 then
				error "trying to use galaktik to restore mp at level 8+"
			elseif need > 50 then
				error "trying to use galaktik to restore more than 50 MP"
			else
				post_page("/galaktik.php", { action = "curemp", pwd = pwd, quantity = need })
				if mp() < amount then
					error("Failed to reach " .. amount .. " MP using galaktik")
				end
			end
		end
	end

	function f.check_sr(day)
		local tbl = ascension["fortune cookie numbers"] or {}
		for a,b in pairs(tbl) do
			if (turnsthisrun() == tonumber(b)) then
				inform "checking for SR"

				local lastsemi = ascension["last semirare encounter"]
				local lastturn = ascension["last semirare turn"]

				local possible = true
				if lastturn then
					if lastturn + 159 > turnsthisrun() then
						possible = false
					end
				elseif turnsthisrun() < 69 then
					possible = false
				end
				if possible then
					print("pick up SR, day", day, "last semi", lastsemi, lastturn)
					if (day == 1 and not lastsemi and not lastturn) then
						inform "Pick up SR day 1, make it lunchbox"
						result, resulturl, advagain = autoadventure(114)
						if result:match("Lunchboxing") then
							use_item("Knob Goblin lunchbox")
							did_action = true
							return result, resulturl, did_action
						end
					elseif lastsemi == "Lunchboxing" then
						inform "Pick up SR, make it wines"
						result, resulturl, advagain = autoadventure(112)
						if result:match("In the Still of the Alley") then
							inform "eating fortune cookie"
							buy_item("fortune cookie", "m")
							local old_full = fullness()
							result, resulturl = eat_item("fortune cookie")
							if fullness() == old_full + 1 then
								did_action = true
							end
							return result, resulturl, did_action
						end
					elseif lastsemi == "In the Still of the Alley" then
						inform "Pick up SR, make it lunchbox"
						result, resulturl, advagain = autoadventure(114)
						if result:match("Lunchboxing") then
							use_item("Knob Goblin lunchbox")
							inform "eating fortune cookie"
							buy_item("fortune cookie", "m")
							local old_full = fullness()
							result, resulturl = eat_item("fortune cookie")
							if fullness() == old_full + 1 then
								did_action = true
							end
							return result, resulturl, did_action
						end
					else
						error "Unknown last SR when picking up SR"
					end
				else
					print("Skipping impossible SR", b, turnsthisrun(), "last", lastsemi, lastturn)
				end
			end
		end
-- 		if not have_numbers then
-- 			if have(want_itemname) and not ascension["fortune cookie numbers"] then
-- 				buy_item("fortune cookie", "m")
-- 				if not have("fortune cookie") then
-- 					error("Failed to buy a fortune cookie")
-- 				end
-- 				eat_item("fortune cookie")
-- 				eat_item(want_itemname)
-- 				if not ascension["fortune cookie numbers"] then
-- 					error("Failed to get fortune cookie numbers set")
-- 				end
-- 			end
-- 		end
	end

	function f.make_reagent_pasta()
		if count("dry noodles") < 1 then
			ensure_mp(10)
			cast_buff(3006, 1) -- pastamastery
		end
		if count("scrumptious reagent") < 1 then
			ensure_mp(10)
			cast_buff(4006, 1) -- advanced saucecrafting
		end
		if have("Hell broth") then
			inform "make hell ramen"
			result, resulturl = cook_items("Hell broth", "dry noodles")
			if have("Hell ramen") then
				did_action = true
			end
		elseif have("fancy schmancy cheese sauce") then
			inform "make fettucini inconnu"
			result, resulturl = cook_items("fancy schmancy cheese sauce", "dry noodles")
			if have("fettucini Inconnu") then
				did_action = true
			end
		elseif have("hellion cube") then
			inform "make hell broth"
			result, resulturl = cook_items("hellion cube", "scrumptious reagent")
			if have("Hell broth") then
				did_action = true
			end
		elseif have("goat cheese") then
			inform "make cheese sauce"
			result, resulturl = cook_items("goat cheese", "scrumptious reagent")
			if have("fancy schmancy cheese sauce") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.eat_food(day)
		if fullness() < 15 then
			if day == 1 then
				local want_item_tbl = {
					Muscle = "Tiger-lily's milk",
					Mysticality = "powdered donut",
					Moxie = "dragon snaps",
				}
				local want_itemname = want_item_tbl[get_mainstat()]
				if have(want_itemname) and fullness() == 0 then
					inform "eat garden food day 1"
					result, resulturl = eat_item(want_itemname)
					if fullness() == 1 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif not ascension["fortune cookie numbers"] and fullness() == 1 then
					inform "eat fortune cookie day 1"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if ascension["fortune cookie numbers"] then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and fullness() == 2 then
					inform "eat pasty day 1"
					result, resulturl = eat_item("Knob pasty")
					if fullness() == 3 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif fullness() == 3 or fullness() == 9 then
					if have("Hell ramen") then
						inform "eat hell ramen day 1"
						eat_item("Hell ramen")
						if advs() >= 20 then
							did_action = true
						end
						return result, resulturl, did_action
					else
						result, resulturl, did_action = f.make_reagent_pasta()
						if did_action == false and result:match("You need a more advanced cooking appliance") then
							if have("Dramatic&trade; range") then
								inform "using dramatic range"
								use_item("Dramatic&trade; range")
								if not have("Dramatic&trade; range") then
									did_action = true
								end
							else
								inform "buying dramatic range"
								buy_item("Dramatic&trade; range", "m")
								if have("Dramatic&trade; range") then
									did_action = true
								end
							end
						end
						return result, resulturl, did_action
					end
				end
			elseif day == 2 then
				-- TODO: check for SR status!
				if fullness() == 0 then
					inform "eat fortune cookie day 2"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if fullness() == 1 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and (fullness() < 3 or fullness() >= 12) then
					inform "eat pasty day 2"
					result, resulturl = eat_item("Knob pasty")
					if advs() >= 20 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif fullness() <= 9 then
					if have("Hell ramen") then
						inform "eat hell ramen day 2"
						eat_item("Hell ramen")
						if advs() >= 20 then
							did_action = true
						end
						return result, resulturl, did_action
					else
						return f.make_reagent_pasta()
					end
				end
			elseif day >= 3 then
				-- TODO: check for SR status!
				if fullness() == 0 then
					inform "eating fortune cookie to start day"
					buy_item("fortune cookie", "m")
					result, resulturl = eat_item("fortune cookie")
					if fullness() == 1 then
						did_action = true
					end
					return result, resulturl, did_action
				elseif have("Knob pasty") and (fullness() < 3 or fullness() >= 12) then
					inform "eating pasty"
					local a = advs()
					result, resulturl = eat_item("Knob pasty")
					if advs() > a then
						did_action = true
					end
					return result, resulturl, did_action
-- 				elseif fullness() <= 3 and have_reagent_pastas >= need_total_reagent_pastas then
				elseif fullness() <= 3 then
					if count("Hell ramen") + count("fettucini Inconnu") >= 2 then
						if buff("Got Milk") then
							inform "eating reagent pasta"
							eat_item("Hell ramen")
							eat_item("Hell ramen")
							eat_item("fettucini Inconnu")
							eat_item("fettucini Inconnu")
							if fullness() >= 12 then
								did_action = true
							end
							return result, resulturl, did_action
						elseif have("milk of magnesium") then
							inform "using milk"
							result, resulturl = use_item("milk of magnesium")
							if buff("Got Milk") then
								did_action = true
							end
							return result, resulturl, did_action
						elseif have("glass of goat's milk") then
							inform "making milk"
							if count("scrumptious reagent") < 1 then
								ensure_mp(10)
								cast_buff(4006, 1) -- advanced saucecrafting
							end
							result, resulturl = cook_items("glass of goat's milk", "scrumptious reagent")
							if have("milk of magnesium") then
								did_action = true
							end
							return result, resulturl, did_action
						end
					else
						return f.make_reagent_pasta()
					end
				end
			end
		end
	end

	function f.drink_booze(day)
		if day == 1 then
			if drunkenness() < 3 and have("Typical Tavern swill") and meat() >= 1000 then
				inform "drinking pumpkin and overpriced beer"
				if not have("pumpkin beer") then
					buy_item("fermenting powder", "m")
					mix_items("pumpkin", "fermenting powder")
				end
				-- IMPROVE?: drink booze and sewerlevel at nice times
				ensure_mp(5)
				cast_buff(8202) -- summon alice's army cards

				ensure_buffs { "Ode to Booze" }
				for i = 1, 10 do
					if drunkenness() < 8 and buff("Ode to Booze") then
						local start_drunk = drunkenness()
						if have("thermos full of Knob coffee") then
							inform "drinking knob coffee"
							drink_item("thermos full of Knob coffee")
						elseif have("pumpkin beer") then
							inform "drinking pumpkin beer"
							drink_item("pumpkin beer")
						elseif have("distilled fortified wine") then
							inform "drinking fortified wine"
							drink_item("distilled fortified wine")
						-- TODO: itemid
	-- 					elseif have("Ye Wizard's Shack snack voucher") then
						elseif have_itemid(5012) and drunkenness() <= 7 then
							inform "drinking gamestore sake"
							post_page("/gamestore.php", { action = "buysnack", whichsnack = 5017 })
							drink_itemid(5017)
						elseif have("cream stout") then
							inform "drinking cream stout"
							drink_item("cream stout")
						elseif have("shot of rotgut") then
							inform "drinking rotgut"
							f.heal_up()
							drink_item("shot of rotgut")
						else
							inform "drinking imported beer"
							buy_item("overpriced &quot;imported&quot; beer", "v", 1)
							drink_item("overpriced &quot;imported&quot; beer")
						end
						if drunkenness() <= start_drunk then
							error "Failed to drink..."
						end
					end
				end
				if drunkenness() >= 3 and buff("Pisces in the Skyces") then
					did_action = true
				end
				return result, resulturl, did_action
			elseif drunkenness() < 12 and have("Typical Tavern swill") and have("thermos full of Knob coffee") and meat() >= 2000 then
				-- TODO: redo
				if not have("coconut shell") and not have("little paper umbrella") and not have("magical ice cubes") then
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
					ensure_mp(10)
					cast_buff(5014, 1) -- advanced cocktailcrafting
				end
				if not have("blended frozen swill") and not have("fruity girl swill") and not have("tropical swill") then
					if have("little paper umbrella") then
						result, resulturl = mix_items("Typical Tavern swill", "little paper umbrella")
					elseif have("magical ice cubes") then
						result, resulturl = mix_items("Typical Tavern swill", "magical ice cubes")
					elseif have("coconut shell") then
						result, resulturl = mix_items("Typical Tavern swill", "coconut shell")
					end
					if have("blended frozen swill") or have("fruity girl swill") or have("tropical swill") then
						did_action = true
					elseif result:match("Your cocktail set is not advanced enough") then
						if have("Queue Du Coq cocktailcrafting kit") then
							inform "using cocktailcrafting kit"
							use_item("Queue Du Coq cocktailcrafting kit")
							if not have("Queue Du Coq cocktailcrafting kit") then
								did_action = true
							end
						else
							inform "buying cocktailcrafting kit"
							buy_item("Queue Du Coq cocktailcrafting kit", "m")
							if have("Queue Du Coq cocktailcrafting kit") then
								did_action = true
							end
						end
					end
				else
					ensure_buffs { "Ode to Booze" }
					if buffturns("Ode to Booze") < 8 then
						error "Failed to cast ode"
					end
					if have("blended frozen swill") then
						drink_item("blended frozen swill")
					elseif have("fruity girl swill") then
						drink_item("fruity girl swill")
					elseif have("tropical swill") then
						drink_item("fruity girl swill")
					end
					if drunkenness() ~= 12 then
						error "Drunkenness after mixed swill isn't 12"
					end
					local thermoses = count("thermos full of Knob coffee")
					if thermoses > 2 then
						thermoses = 2
					end
					local imported = 2 - thermoses
					buy_item("overpriced &quot;imported&quot; beer", "v", imported)
					for t = 1, thermoses do
						drink_item("thermos full of Knob coffee")
					end
					for i = 1, imported do
						drink_item("overpriced &quot;imported&quot; beer")
					end
					if drunkenness() ~= 14 then
						error "Drunkenness after thermoses/beer isn't 14"
					end
					if buffturns("Ode to Booze") < 8 then
						did_action = true
					else
						error "Something went wrong when drinking booze"
					end
				end
				return result, resulturl, did_action
			end
		elseif day >= 2 then
			if drunkenness() < 19 and meat() >= 2000 then
				if have("pumpkin") then
					buy_item("fermenting powder", "m")
					mix_items("pumpkin", "fermenting powder")
				end
				ensure_mp(5)
				cast_buff(8202) -- summon alice's army cards
				inform "drinking booze"
				if have("steel margarita") then
					error "Drink steel margarita first!"
				end
				for i = 1, 20 do
					if drunkenness() < 19 then
						local start_drunk = drunkenness()
						ensure_buffs { "Ode to Booze" }
						if have("thermos full of Knob coffee") then
							inform "drinking knob coffee"
							drink_item("thermos full of Knob coffee")
						elseif have("pumpkin beer") then
							inform "drinking pumpkin beer"
							drink_item("pumpkin beer")
						elseif have("distilled fortified wine") then
							inform "drinking fortified wine"
							drink_item("distilled fortified wine")
						-- TODO: itemid
	-- 					elseif have("Ye Wizard's Shack snack voucher") then
						elseif have_itemid(5012) and drunkenness() <= 16 then
							inform "drinking gamestore sake"
							post_page("/gamestore.php", { action = "buysnack", whichsnack = 5017 })
							drink_itemid(5017)
						elseif have("cream stout") then
							inform "drinking cream stout"
							drink_item("cream stout")
						elseif have("shot of rotgut") then
							inform "drinking rotgut"
							f.heal_up()
							drink_item("shot of rotgut")
						else
							inform "drinking imported beer"
							buy_item("overpriced &quot;imported&quot; beer", "v", 1)
							drink_item("overpriced &quot;imported&quot; beer")
						end
						if drunkenness() <= start_drunk then
							error "Failed to drink..."
						end
					end
				end
				if drunkenness() == 19 then
					did_action = true
				end
				return result, resulturl, did_action
			end
		end
	end

	function f.get_photocopied_monster()
		if have("photocopied monster") then
			local itempt = get_page("/desc_item.php", { whichitem = "835898159" })
			local copied = itempt:match([[blurry likeness of [a-zA-Z]* (.-) on it.]])
			return copied
		else
			return nil
		end
	end

	function f.go(info, zoneid, macro, noncombattbl, buffslist, famname, minmp, extra)
		local specialnoncombatfunction = nil
		local towear = {}
		if extra then
			if extra.olfact then
				if not trailed then
					minmp = minmp + 40
				elseif trailed ~= extra.olfact then
					error("Trailing " .. trailed .. " when trying to olfact " .. extra.olfact)
				end
				extra.olfact = nil
			end
			if extra.choice_function then
				specialnoncombatfunction = extra.choice_function
				extra.choice_function = nil
			end
			if extra.equipment then
				towear = extra.equipment
				extra.equipment = nil
			end
			unhandled = false
			for a, b in pairs(extra) do
				print("extra." .. a .. " = " .. tostring(b) .. " unhandled!")
				unhandled = "extra." .. a .. " = " .. tostring(b)
			end
			if unhandled then
				error("unhandled: " .. unhandled)
			end
		end
		if mcd() ~= 10 and level() < 13 then
			set_mcd(10)
		elseif mcd() ~= 0 and level() == 13 then
			set_mcd(0)
		end
		inform(info)
		ensure_buffs(buffslist)
		fam(famname)
		f.heal_up()
		if familiar_data[famname].mpregen then
			f.burn_mp(minmp + 20)
		end
		if not have("fixed-gear bicycle") and have("ironic moustache") then
			unequip_slot("familiarequip")
			use_item("ironic moustache")
			use_item("chiptune guitar")
			if not have("fixed-gear bicycle") then
				error "Failed to turn moustache into bicycle"
			end
		end
		if familiar_data[famname].familiarequip and not towear.familiarequip and have(familiar_data[famname].familiarequip) then
			towear.familiarequip = familiar_data[famname].familiarequip
		end
		wear(towear)
		ensure_mp(minmp)
		result, resulturl, advagain = autoadventure(zoneid, macro, noncombattbl, specialnoncombatfunction)
		did_action = advagain
		if not did_action then
			local need_mainstat = tonumber(result:match("<center>%(You must have at least ([0-9]+) [A-Za-z]+ to adventure here.%)</center>"))
			if need_mainstat and need_mainstat > buffedmainstat() then
				if get_mainstat() == "Muscle" then
					ensure_buffs{"Go Get 'Em, Tiger!"}
				elseif get_mainstat() == "Mysticality" then
					ensure_buffs{"Glittering Eyelashes"}
				elseif get_mainstat() == "Moxie" then
					ensure_buffs{"Butt-Rock Hair"}
				end
				get_page("/charpane.php") -- HACK: Workaround for CDM bug
				if buffedmainstat() >= need_mainstat then
					did_action = true
				end
			end
		end
		return result, resulturl, advagain
	end

	function f.do_muscle_powerleveling()
		print("mainstat", basemainstat(), "advs", advs())
		if have("Spookyraven gallery key") then
			local function find_solution(from_choicenum)
				local found = {}
				local reached = {}
				local available = {}
				available[from_choicenum] = -1000
				for i = 1, 1000 do
					local new_available = {}
					local found_any = false
					for choicenum, source in pairs(available) do
						found_any = true
						reached[choicenum] = source
						for initialc = 1, 3 do
							local initialto = ascension["louvre.map.adventure." .. choicenum .. ".choice." .. initialc]
							if initialto then
								local tochoice = initialto:match("^choice ([0-9]+)$")
								local toresult = initialto:match("^result (.+)$")
								if tochoice then
									if not reached[tochoice] and not available[tochoice] then
										new_available[tochoice] = { whichchoice = choicenum, option = initialc }
									end
								end
								if toresult then
									if not found[toresult] then
										found[toresult] = { whichchoice = choicenum, option = initialc }
									end
								end
							end
						end
					end
					available = new_available
					if not found_any then
						break
					end
				end
				return found, reached
			end
			go("muscle powerleveling", 106, macro_noodlecannon, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic", "Butt-Rock Hair", "A Few Extra Pounds" }, "Rogue Program", 35, { choice_function = function (advtitle, choicenum)
				if advtitle == "Out in the Garden" then
					return "The second knight"
				else
					local found, reached = find_solution(choicenum)
					local mus = found["Gain muscle"]
					if mus then
						function trace(source)
							if source == -1000 then
								return {}
							else
								local tbl = trace(reached[source.whichchoice])
								table.insert(tbl, source)
								return tbl
							end
						end
						local t = trace(mus)
						if t[1].whichchoice == choicenum then
							return "", t[1].option
						else
							error "TODO: Explore louvre to locate muscle adventure"
						end
					end
				end
			end})
		elseif ascension["zone.conservatory.gallery key"] == "unlocked" then
			go("pick up gallery key", 103, macro_stasis(), {}, {}, "Mini-Hipster", 5)
		else
			go("unlock gallery key", 104, macro_stasis(), {}, {"Smooth Movements", "The Sonata of Sneakiness", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 5, { choice_function = function (advtitle, choicenum)
				if advtitle == "Take a Look, it's in a Book!" then
					if choicenum == 80 then
						return "Reading is for losers.  I'm outta here."
					elseif choicenum == 81 then
						return "Read &quot;The Fall of the House of Spookyraven&quot;"
					end
				elseif advtitle == "History is Fun!" then
					return "Read Chapter 2: Stephen and Elizabeth"
				end
			end})
		end
	end

	function f.do_mysticality_powerleveling()
		print("mainstat", basemainstat(), "advs", advs())
		go("mysticality powerleveling", 107, macro_noodlecannon, {
			["Don't Hold a Grudge"] = "Declare a thumb war",
			["Having a Medicine Ball"] = "Gaze deeply into the mirror",
		}, { "Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic" }, "Rogue Program", 25)
	end

	function f.do_moxie_powerleveling()
		print("mainstat", basemainstat(), "dance cards", count("dance card"), "advs", advs(), "trail turns", buffturns("On the Trail"))
		go("moxie powerleveling", 109, make_cannonsniff_macro("zombie waltzers"), {
			["Curtains"] = "Watch the dancers",
			["Strung-Up Quartet"] = "&quot;Play 'Sono Un Amanten Non Un Combattente'&quot;",
		}, {"Smooth Movements", "The Sonata of Sneakiness", "Spirit of Garlic"}, "Slimeling", 20, { olfact = "zombie waltzers" })
	end

	function f.do_moxie_use_dancecard()
		if have("dance card") then
			local dance_card_turn = tonumber(ascension["dance card turn"]) or -1000
			if dance_card_turn < turnsthisrun() then
				return use_item("dance card")
			end
		end
	end

	function f.ensure_buffs(xs)
		local buffs = {
			["Go Get 'Em, Tiger!"] = function()
				buy_item("Ben-Gal&trade; Balm", "m", 5)
				return use_item("Ben-Gal&trade; Balm", 5)
			end,
			["Glittering Eyelashes"] = function()
				buy_item("glittery mascara", "m", 5)
				return use_item("glittery mascara", 5)
			end,
			["Butt-Rock Hair"] = function()
				buy_item("hair spray", "m", 5)
				return use_item("hair spray", 5)
			end,
			["Heavy Petting"] = function()
				if not have("Knob Goblin pet-buffing spray") then
					buy_item("Knob Goblin pet-buffing spray", "k", 1)
				end
				return use_item("Knob Goblin pet-buffing spray")
			end,
			["Peeled Eyeballs"] = function()
				if not have("Knob Goblin eyedrops") then
					buy_item("Knob Goblin eyedrops", "k", 1)
				end
				return use_item("Knob Goblin eyedrops")
			end,
			["Brother Flying Burrito's Blessing"] = function()
				return post_page("/friars.php", { pwd = pwd, action = "buffs", bro = "1" })
			end,
			["Mental A-cue-ity"] = function()
				return get_page("/clan_viplounge.php", { preaction = "poolgame", stance = "2" })
			end,
		}
		if get_mainstat() == "Mysticality" and level() >= 6 then
			table.insert(xs, "A Few Extra Pounds")
		end
		if level() >= 6 then
			table.insert(xs, "Leash of Linguini")
			table.insert(xs, "Empathy")
		end
		local spells = {
			["The Moxious Madrigal"] = { spellid = 6004, mpcost = 2, effectid = 61 },
			["The Magical Mojomuscular Melody"] = { spellid = 6007, mpcost = 3, effectid = 64 },
			["Musk of the Moose"] = { spellid = 1019, mpcost = 10 },
			["A Few Extra Pounds"] = { spellid = 1024, mpcost = 10 },
			["Ghostly Shell"] = { spellid = 2007, mpcost = 6 },
			["Empathy"] = { spellid = 2009, mpcost = 15 },
			["Astral Shell"] = { spellid = 2012, mpcost = 10 },
			["Leash of Linguini"] = { spellid = 3010, mpcost = 12 },
			["Springy Fusilli"] = { spellid = 3015, mpcost = 10 },
			["Spirit of Peppermint"] = { spellid = 3102, mpcost = 10 },
			["Spirit of Garlic"] = { spellid = 3103, mpcost = 10 },
			["Spirit of Bacon Grease"] = { spellid = 3105, mpcost = 10 },
			["Jalape&ntilde;o Saucesphere"] = { spellid = 4008, mpcost = 5 },
			["Jaba&ntilde;ero Saucesphere"] = { spellid = 4011, mpcost = 10 },
			["Smooth Movements"] = { spellid = 5017, mpcost = 10 },
			["Fat Leon's Phat Loot Lyric"] = { spellid = 6010, mpcost = 11, effectid = 67 },
			["The Sonata of Sneakiness"] = { spellid = 6015, mpcost = 20, effectid = 162, shrug_first = "Carlweather's Cantata of Confrontation" },
			["Carlweather's Cantata of Confrontation"] = { spellid = 6016, mpcost = 20, effectid = 163, shrug_first = "The Sonata of Sneakiness" },
			["Ur-Kel's Aria of Annoyance"] = { spellid = 6017, mpcost = 30, effectid = 164 },
			["Ode to Booze"] = { spellid = 6014, mpcost = 50, effectid = 71 },
		}
		local function shrug_buff(buffname)
			if buff(buffname) then
-- 				print("shrugging buff", buffname, effectid)
				get_page("/charsheet.php", { pwd = pwd, ajax = 1, action = "unbuff", whichbuff = spells[buffname].effectid })
				if buff(buffname) then
					error("Failed to shrug buff: " .. buffname)
				end
			end
		end
		for name, data in pairs(spells) do
			buffs[name] = function()
-- 				print("casting buff", name)
				ensure_mp(data.mpcost)
				if data.shrug_first then
					shrug_buff(data.shrug_first)
				end
				return cast_buff(data.spellid)
			end 
		end
		local want_buffs = {}
		for _, x in pairs(xs) do
			want_buffs[x] = true
		end
		local at_shruggable = {
			"Ode to Booze",
			"Carlweather's Cantata of Confrontation",
			"The Sonata of Sneakiness",
			"The Moxious Madrigal",
			"The Magical Mojomuscular Melody",
			"Fat Leon's Phat Loot Lyric",
		}
		if level() >= 13 and buff("Ur-Kel's Aria of Annoyance") and not want_buffs["Ur-Kel's Aria of Annoyance"] then
			shrug_buff("Ur-Kel's Aria of Annoyance")
			set_mcd(0) -- HACK: don't do this here!
		end
		if buff("Ode to Booze") and not want_buffs["Ode to Booze"] then
			shrug_buff("Ode to Booze")
		end
		local function try_casting_buff(buffname, try_shrugging)
			if buffs[buffname] then
				local pt, pturl = buffs[buffname]()
				if not buff(buffname) then
					if pt:contains("too many songs stuck in your head") and try_shrugging then
						for _, atname in pairs(at_shruggable) do
							if buff(atname) and not want_buffs[atname] then
								shrug_buff(atname)
								return try_casting_buff(buffname, false)
							end
						end
						error("too many AT songs to cast buff: " .. buffname)
					else
						error("failed to ensure buff: " .. buffname)
					end
				end
				return pt, pturl
			else
				error("trying to ensure unknown buff: " .. buffname)
			end
		end
		for _, x in pairs(xs) do
			if not buff(x) then
				local pt, pturl = try_casting_buff(x, true)
				if not buff(x) then
					result, resulturl = pt, pturl
					return result, resulturl
				end
			end
		end
	end

	function f.wear(tbl)
		local defaults = {
			hat = {
				{ name = "reinforced beaded headband", check = (basemoxie() >= 70) },
				{ name = "beer helmet", check = (basemoxie() >= 70) },
				{ name = "worn tophat", check = (basemoxie() >= 47) },
				{ name = "Crown of the Goblin King", check = (basemoxie() >= 20) },
				"miner's helmet",
				{ name = "powdered wig", check = (basemoxie() >= 20) },
				"cornuthaum",
				"Knob Goblin elite helm",
				"snorkel",
			},
			shirt = {
				"sugar shirt",
				{ name = "yak anorak", check = (basemuscle() >= 42) },
			},
			pants = {
				{ name = "leather chaps", check = (basemoxie() >= 65) },
				{ name = "distressed denim pants", check = (basemoxie() >= 70) },
				{ name = "bullet-proof corduroys", check = (basemoxie() >= 70) },
				"miner's pants",
				"swashbuckling pants",
				"Boss Bat britches",
				"Knob Goblin elite pants",
				"old sweatpants",
			},
			acc1 = {
				"observational glasses",
			},
			acc2 = {
				"Cape of the Goblin King",
			},
			acc3 = {
				{ name = "stainless steel solitaire", check = (basemysticality() >= 30) },
				{ name = "stainless steel suspenders", check = (basemysticality() >= 30) },
				{ name = "badass belt", check = (basemysticality() >= 35) },
				{ name = "shiny ring", check = (basemysticality() >= 10) },
			},
		}
		-- TODO: add a lookup for equip requirements
		-- TODO: handle accessories better
		local neweq = {}
		for a, b in pairs(defaults) do
			if not tbl[a] then
				for _, x in pairs(b) do
					local itemname = nil
					if type(x) == "string" then
						if have(x) then
							itemname = x
						end
					elseif type(x) == "table" then
						if have(x.name) and x.check then
							itemname = x.name
						end
					end
					if itemname then
						neweq[a] = get_itemid(itemname)
						break
					end
				end
			end
		end
		for a, b in pairs(tbl) do
			if b == "empty" then
				neweq[a] = nil
			else
				neweq[a] = get_itemid(b)
			end
		end
-- 		print("setting equipment: ", table_to_str(neweq))
		set_equipment(neweq)
	end

	function f.get_big_book_of_pirate_insults()
		if not have("dingy dinghy") and meat() >= 500 then
			inform "make dingy dinghy"
			if not have("dinghy plans") then
				inform "shore for dinghy plans"
				local function get_shore_trips()
					local pt, pturl = get_page("/shore.php")
					local trips = pt:match("You have taken (.-) trip")
					if trips == "no" then
						trips = 0
					elseif trips == "one" then
						trips = 1
					else
						trips = tonumber(trips)
					end
					return trips
				end
				local trips = get_shore_trips()
				local function do_trip(tripid)
					result, resulturl = post_page("/shore.php", { pwd = pwd, whichtrip = tripid })
					local new_trips = get_shore_trips()
					if new_trips > trips then
						did_action = true
					end
				end
				local shore_tower_items = {
					["stick of dynamite"] = 1,
					["tropical orchid"] = 2,
					["barbed-wire fence"] = 3,
				}

				local tbl = ascension["zone.lair.itemsneeded"] or {}
				local need_item = nil
				local want_adv = nil
				for from, to in pairs(tbl) do
					if shore_tower_items[to] then
						need_item = to
						want_adv = shore_tower_items[to]
					end
				end
				if not need_item then
					error "Don't know which shore tower item is needed."
				end
				if trips == 1 and not have(need_item) then
					do_trip(want_adv)
					did_action = false
					if have(need_item) then
						did_action = true
					end
				elseif trips >= 2 and trips < 5 and have(need_item) then
					local whichtrip = {
						["Muscle"] = 1,
						["Mysticality"] = 2,
						["Moxie"] = 3,
					}
					do_trip(whichtrip[get_mainstat()])
				end
			elseif not have("dingy planks") then
				inform "get dingy planks from hermit"
				f.ensure_worthless_item()
				buy_item("hermit permit", "m")
				result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("dingy planks"), quantity = 1 })
				if have("dingy planks") then
					did_action = true
				else
					error "Failed to buy dingy planks"
				end
			else
				use_item("dinghy plans")
				if have("dingy dinghy") then
					did_action = true
				end
			end
		elseif meat() < 1500 then
			error "Not enough meat for insult book + dictionary"
		elseif have("eyepatch") and have("swashbuckling pants") and have("stuffed shoulder parrot") and not have("The Big Book of Pirate Insults") then
			inform "buy insult book and dictionary"
			wear { hat = "eyepatch", pants = "swashbuckling pants", acc1 = "stuffed shoulder parrot" }
			buy_item("The Big Book of Pirate Insults", "r")
			buy_item("abridged dictionary", "r")
			if have("The Big Book of Pirate Insults") and have("abridged dictionary") then
				did_action = true
			end
		else
			go("get swashbuckling outfit", 66, macro_noodlecannon, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric" }, "Slimeling", 25, { choice_function = function (advtitle, choicenum)
				if advtitle == "Amatearrr Night" then
					if not have("stuffed shoulder parrot") then
						return "What's orange and sounds like a parrot?" -- stuffed shoulder parrot
					else
						return "What's gold and sounds like a pirate?" -- eyepatch
					end
				elseif advtitle == "The Arrrbitrator" then
					if not have("eyepatch") then
						return "Vote for Jack Robinson" -- eyepatch
					else
						return "Vote for Sergeant Hook" -- swashbuckling pants
					end
				elseif advtitle == "Barrie Me at Sea" then
					if not have("swashbuckling pants") then
						return "Help Captain Ladle" -- swashbuckling pants
					else
						return "Help Sammy Skillet" -- stuffed shoulder parrot
					end
				end
			end })
		end
		return result, resulturl, did_action
	end

	function f.do_8bit_realm()
		pixels = count("red pixel")
		if count("green pixel") < pixels then
			pixels = count("green pixel")
		end
		if count("blue pixel") < pixels then
			pixels = count("blue pixel")
		end
		pixels = pixels + count("white pixel")
		if pixels < 30 then
			if not have("continuum transfunctioner") then
				inform "pick up continuum transfunctioner"
				get_page("/mystic.php")
				post_page("/mystic.php", { action = "crackyes1" })
				post_page("/mystic.php", { action = "crackyes2" })
				result, resulturl = post_page("/mystic.php", { action = "crackyes3" })
				if have("continuum transfunctioner") then
					did_action = true
				end
			else
				go("farm pixels for digital key: " .. pixels, 73, macro_autoattack, nil, {"Spirit of Garlic", "Fat Leon's Phat Loot Lyric"}, "Stocking Mimic", 15, { olfact = "Blooper", equipment = { weapon = "hilarious comedy prop", offhand = "continuum transfunctioner" } })
			end
		elseif count("white pixel") < 30 then
			inform "make white pixels"
			local to_make = 30 - count("white pixel")
			post_page("/mystic.php", { action = "makepixel", pwd = pwd, makewhich = get_itemid("white pixel"), quantity = to_make })
			if count("white pixel") >= 30 then
				did_action = true
			end
		else
			inform "make digital key"
			post_page("/mystic.php", { action = "makepixel", pwd = pwd, makewhich = get_itemid("digital key"), quantity = 1 })
			wear {} -- TODO: should not be necessary
			if have("digital key") and have_inventory("continuum transfunctioner") and have_inventory("hilarious comedy prop") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.buy_use_chewing_gum()
		inform "use chewing gum"
		if not have("chewing gum on a string") then
			buy_item("chewing gum on a string", "m")
			if not have("chewing gum on a string") then
				error "Couldn't buy chewing gum"
			end
		end
		result, resulturl = use_item("chewing gum on a string")
		if result:match("You acquire") then
			did_action = true
		end
		return result, resulturl, did_action
	end

	function f.get_starting_items()
		if not ((have("stolen accordion") or have("Rock and Roll Legend")) and have("turtle totem") and have("saucepan")) then
			return f.buy_use_chewing_gum()
		end

		if not have("Rock and Roll Legend") then
			inform "pick up RnR"
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("hot buttered roll"), quantity = 1 })
			if not have("hot buttered roll") then
				error "Failed to buy hot buttered roll"
			end
			if not have("casino pass") then
				result, resulturl = buy_item("casino pass", "m")
				if not have("casino pass") then
					error "Failed to buy casino pass"
				end
			end
			if not have("big rock") then
				if not have("ten-leaf clover") and have("disassembled clover") then
					result, resulturl = use_item("disassembled clover")
				end
				if not have("ten-leaf clover") then
					error "No ten-leaf clover"
				end
				ensure_buffs { "Mental A-cue-ity" }
				result, resulturl = get_page("/casino.php", { action = "slot", whichslot = "11" })
				if not have("big rock") then
					error "Didn't get big rock"
				end
			end
			result, resulturl = smith_items("hot buttered roll", "big rock")
			result, resulturl = smith_items("heart of rock and roll", "stolen accordion")
			if have("Rock and Roll Legend") then
				did_action = true
			end
			return result, resulturl, did_action
		end

		if not have("seal tooth") then
			inform "pick up seal tooth"
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			result, resulturl = post_page("/hermit.php", { action = "trade", whichitem = get_itemid("seal tooth"), quantity = 1 })
			if have("seal tooth") then
				did_action = true
			else
				error "Failed to buy seal tooth"
			end
			return result, resulturl, did_action
		end
	end

	function f.do_starting_stuff()
		if not have("Clan VIP Lounge key") then
			print("pulling VIP key")
			freepull_itemid(get_itemid("Clan VIP Lounge key"))
			get_page("/clan_viplounge.php", { action = "lookingglass" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			get_page("/clan_viplounge.php", { action = "klaw" })
			if have("Clan VIP Lounge key") then
				did_action = true
			end
		elseif council_text:contains("visit the Toot Oriole") then
			print("doing toot quest")
			get_page("/tutorial.php", { action = "toot" })
			use_item("Newbiesport&trade; tent")
			use_item("letter from King Ralph XI")
			use_item("pork elf goodies sack")

			ensure_mp(6)
			cast_buff(8002, 3) -- summon sugar sheet
			get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shield") })
			get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar chapeau") })
			get_page("/sugarsheets.php", { pwd = pwd, action = "fold", whichitem = get_itemid("sugar shirt") })

			wear {} -- TODO: should not be necessary

			get_page("/campground.php")
			get_page("/campground.php", { action = "garden", pwd = pwd })

			post_page("/campground.php", { action = "telescopelow" })

	-- 		post_page("/campground.php", { smashstone = "Yep.", pwd = pwd, confirm = "on" })

			did_action = true
		elseif meat() < 5000 and (have("baconstone") or have("hamethyst") or have("porquoise")) then
			print("selling pork gems")
			if count("baconstone") > 10 or count("hamethyst") > 10 or count("porquoise") > 10 then
				error "we somehow have lots of pork gems"
			else
				sell_itemid(get_itemid("baconstone"), count("baconstone"))
				sell_itemid(get_itemid("hamethyst"), count("hamethyst"))
				sell_itemid(get_itemid("porquoise"), count("porquoise"))
				buy_item("detuned radio", "5")
				set_mcd(10)
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_strange_leaflet()
		inform "doing strange leaflet"
		local function do_leaflet() -- TODO: merge, copypasted from leaflet.lua
			local function pp(cmds)
				local t = nil
				for _, c in pairs(cmds) do
					t = post_page("/leaflet.php", { pwd = pwd, command = c })
				end
				return t
			end
			pp { "open door", "east", "take sword", "look at tinder", "take parchment" }
			local manteltext, manteluri = pp { "look at mantel" }
			local magic_words = {
				["small brick building"] = "plugh",
				["model ship inside a bottle"] = "yoho",
				["carved driftwood bird"] = "plover",
				["small white house"] = "xyzzy",
			}
			local magic = nil
			for a,b in pairs(magic_words) do
				if manteltext:match(a) then
					magic = b
				end
			end
			if magic == nil then
				text = manteltext
			else
				print("the magic word is", magic)
				pp { magic }
				pp { "west", "north", "take stick", "cut hedge", "west", "light stick", "east" }

				pp { "north", "kill snake", "open chest", "look behind chest", "look in hole", "south", "south" }

				pp { "east", "light fire", "take boots", "wear boots", "west" }

				pp { "south", "south" }
				pp { "south", "south" }

				print("exploring maze")
				for i = 1, 10 do
					pp { "north", "west", "east", "south" }
				end

				print("finishing leaflet")
				pp { "up", "take egg", "throw egg at roadrunner", "down" }
				pp { "move leaves", "up", "throw ruby at bowl" }
				pp { "gnusto cleesh", "up", "cleesh giant", "take ring", "win game" }
				text = pp { "exit" }

				print("leaflet done")
				text = [[<script type="text/javascript">top.charpane.location.href="charpane.php";</script>]] .. text
			end
		end
		use_item("strange leaflet")
		do_leaflet()
		if have("grue egg") then
			did_action = true
		end
		return result, resulturl, did_action
	end

	function f.unlock_hidden_temple()
		-- spooky forest
		if have("Spooky Temple map") and have("Spooky-Gro fertilizer") and have("spooky sapling") then
			inform "use spooky temple map"
			use_item("Spooky Temple map")
			local newwoodspt = get_page("/woods.php")
			if newwoodspt:contains("The Hidden Temple") then
				did_action = true
			end
		else
			if meat() < 100 then
				error "Not enough meat for spooky sapling"
			end
			go("get parts to unlock hidden temple", 15, macro_stasis(), {}, {"Smooth Movements", "The Sonata of Sneakiness"}, "Rogue Program", 10, { choice_function = function (advtitle, choicenum)
				if advtitle == "Arboreal Respite" then
					if not have("Spooky Temple map") then
						if not have("tree-holed coin") then
							return "Explore the stream"
						else
							return "Brave the dark thicket"
						end
					elseif not have("Spooky-Gro fertilizer") then
						return "Brave the dark thicket"
					elseif not have("spooky sapling") then
						return "Follow the old road"
					end
				elseif advtitle == "Consciousness of a Stream" then
					if not have("Spooky Temple map") and not have("tree-holed coin") then
						inform "get coin"
						return "Squeeze into the cave"
					end
				elseif advtitle == "Through Thicket and Thinnet" then
					if not have("Spooky Temple map") then
						return "Follow the coin"
					elseif not have("Spooky-Gro fertilizer") then
						inform "get fertilizer"
						return "Investigate the dense foliage"
					end
				elseif advtitle == "O Lith, Mon" then
					inform "get map"
					return "Insert coin to continue"
				elseif advtitle == "The Road Less Traveled" then
					if not have("spooky sapling") then
						return "Talk to the hunter"
					end
				elseif advtitle == "Tree's Last Stand" then
					if not have("spooky sapling") then
						inform "buying sapling"
						return "Buy a tree for 100 Meat"
					else
						return "Take your leave"
					end
				end
			end })
-- BUG: reads adventure title as Results. temp. workaround.
-- noncombat: {Results:} (504)
-- fallback for	Results:	504
			if not did_action and have("spooky sapling") and result:contains("Results:") then
				result, resulturl = post_page("/choice.php", { pwd = pwd, whichchoice = 504, option = 4 })
				result, resulturl, advagain = handle_adventure_result(result, resulturl, 15, nil, {})
				did_action = advagain
			end
		end
		return result, resulturl, did_action
	end

	function f.knob_goblin_king_with_cake(killmacro)
		if have("Knob cake") then
			inform "fight king in guard outfit"
			wear { hat = "Knob Goblin elite helm", weapon = "Knob Goblin elite polearm", pants = "Knob Goblin elite pants" }
			ensure_mp(40)
			ensure_buffs{"Springy Fusilli", "Spirit of Garlic"}
			fam "Frumious Bandersnatch"
			set_mcd(7) -- TODO: moxie-specific
			local pt, url = get_page("/cobbsknob.php", { action = "throneroom" })
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", killmacro)
			set_mcd(10)
			wear {}
			did_action = advagain
		elseif have("unfrosted Knob cake") and have("Knob frosting") then
			inform "frost cake"
			result, resulturl = cook_items("unfrosted Knob cake", "Knob frosting")
			if have("Knob cake") then
				did_action = true
			end
		elseif have("Knob cake pan") and have("Knob batter") then
			inform "make unfrosted knob cake"
			result, resulturl = cook_items("Knob cake pan", "Knob batter")
			if have("unfrosted Knob cake") then
				did_action = true
			end
		else
			inform "get cake bits in guard outfit"
			wear { hat = "Knob Goblin elite helm", weapon = "Knob Goblin elite polearm", pants = "Knob Goblin elite pants" }
			result, resulturl, advagain = autoadventure(258)
			did_action = advagain
			if result:contains("it's a key") and result:contains("Knob lab key") then
				did_action = true
			end
			wear {}
		end
		return result, resulturl, did_action
	end

	function f.open_myst_guildstore()
		inform "unlock myst guild store"
		if meat() < 100 then
			error "Not enough meat for mmj"
		end
		buy_item("magical mystery juice", "2")
		if have("magical mystery juice") then
			did_action = true
		else
			print("buffedmainstat is", buffedmainstat())
			if buffedmainstat() < 25 then
				print("ensuring eyelashes")
				ensure_buffs{"Glittering Eyelashes"}
			end
			get_page("/charpane.php") -- Workaround for CDM bug
			print("buffedmainstat is", buffedmainstat())
			if buffedmainstat() < 25 then
				error("Need more myst to unlock guild store reliably (" .. buffedmainstat() .. " < 25)")
			end
			print("doing challenge")
			post_page("/guild.php", { action = "chal" })
			-- TODO: check result!
			did_action = true
		end
		return result, resulturl, did_action
	end

	function f.do_rqg()
		inform "doing red queen's garden"
		if buff("Down the Rabbit Hole") then
			print("red/yellow raying in garden")
			fam "He-Boulder"
			if not buff("Everything Looks Red") then
				ensure_buffs {"Leash of Linguini"}
				wear { familiarequip = "sugar shield" }
			else
				wear {}
			end
			f.heal_up()
			ensure_mp(7)
			local want_monstername = "XXXnothingXXX"
			local call_redray_line = ""
			if not buff("Everything Looks Yellow") then
				local want_monster_tbl = {
					Muscle = "Tiger-lily",
					Mysticality = "wasp",
					Moxie = "snapdragon",
				}
				want_monstername = want_monster_tbl[get_mainstat()]
			end
			if not buff("Everything Looks Red") then
				call_redray_line = [[call do_redray
goto m_done
]]
			end
			local macro_garden = [[
abort pastround 20
abort hppercentbelow 50
scrollwhendone

sub stall
  if hppercentbelow 75
	cast saucy salve
	goto do_return
  endif
  if hasskill Static Shock
	cast Static Shock
	goto do_return
  endif
  if hascombatitem seal tooth
	use seal tooth
	goto do_return
  endif
  if hascombatitem spices
	use spices
	goto do_return
  endif
  mark do_return
endsub

sub do_yellowray
  while !times 15
	if match "yellow eye"
	  cast Point at your opponent
	  goto yellowray_done
	endif
	call stall
  endwhile
  mark yellowray_done
endsub

sub do_redray
  while !times 15
	if match "red eye"
	  cast Point at your opponent
	  goto redray_done
	endif
	call stall
  endwhile
  mark redray_done
endsub

sub do_killgarden
  while !times 15
	if match "red eye"
	  if hasskill Point at your opponent
	    cast Point at your opponent
	  endif
	endif
	cast Cannelloni Cannon
  endwhile
endsub

cast Entangling Noodles

if monstername ]] .. want_monstername .. [[

  call do_yellowray
  goto m_done
endif

]] .. call_redray_line .. [[


call do_killgarden

mark m_done

]]
			result, resulturl, advagain = autoadventure(225, macro_garden)
			unequip_slot("familiarequip")
			did_action = advagain
		elseif have("&quot;DRINK ME&quot; potion") then
			inform "using drink me pot, getting cat-alyzed"
			if not have("snorkel") then
				buy_item("snorkel", "z")
			end
			wear { hat = "snorkel" }
			use_item("&quot;DRINK ME&quot; potion")
			get_page("/rabbithole.php", { action = "teaparty" })
			-- TODO: do with handle_result
			post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get snorkel hatter buff
			if buff("Cat-Alyzed") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.make_star_key()
		local got_enough = false
		if count("star chart") >= 3 then
			if count("star") > 8+5 and count("line") > 7+3 then
				sparestars = count("star") - 8 - 5
				sparelines = count("line") - 7 - 3
				if sparestars >= 5 and sparelines >= 6 then
					got_enough = true
				elseif sparestars >= 6 and sparelines >= 5 then
					got_enough = true
				elseif sparestars >= 7 and sparelines >= 4 then
					got_enough = true
				end
			end
		end
		if got_enough then
			inform "make star stuff"
			if not have("Richard's star key") then
				post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "8", numlines = "7" })
			end
			if not have("star hat") then
				post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "5", numlines = "3" })
			end
			if not have("star crossbow") and not have("star staff") and not have("star sword") then
				if count("star") >= 5 and count("line") >= 6 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "5", numlines = "6" })
				elseif count("star") >= 6 and count("line") >= 5 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "6", numlines = "5" })
				elseif count("star") >= 7 and count("line") >= 4 then
					post_page("/starchart.php", { action = "makesomething", pwd = pwd, numstars = "7", numlines = "4" })
				end
			end
			if have("Richard's star key") and have("star hat") and (have("star crossbow") or have("star staff") or have("star sword")) then
				did_action = true
			end
		else
			if trailed and trailed == "Astronomer" then
				error("Trailing " .. trailed .. " when finishing hits")
			end
			go("finish hits", 83, macro_noodlecannon, {}, { "Spirit of Peppermint", "Fat Leon's Phat Loot Lyric", "Heavy Petting", "Peeled Eyeballs", "Leash of Linguini", "Empathy" }, "Slimeling", 40)
		end
		return result, resulturl, did_action
	end

	function f.do_tavern()
		if quest_text("You should head back to Bart") then
			result, resulturl = get_page("/tavern.php", { place = "barkeep" })
			if have("Typical Tavern swill") then
				did_action = true
			end
		elseif quest_text("Bart Ender wants you to head down") then
			inform "do rat cellar"
			cellarpt = get_page("/cellar.php")
			local function explore()
				tiles = { 4, 3, 2, 1, 6, 11, 16, 17, 21, 22 }
				for _, x in pairs(tiles) do
					if cellarpt:contains("whichspot=" .. x .. ">") then
						inform("exploring tile " .. x)
						return get_page("/cellar.php", { action = "explore", whichspot = x })
					end
				end
				error "No suitable tile found"
			end
			fam "Rogue Program"
			f.heal_up()
			f.burn_mp(20)
			ensure_mp(5)
			local pt, url = explore()
			-- TODO: handle barrels better
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_stasis(), {
				["1984 Had Nothing on This Cellar"] = "Dump out the crate",
				["A Rat's Home..."] = "Kick over the castle",
				["Crate Expectations"] = "Smash the crates",
				["Staring Down the Barrel"] = "Smash the barrel",
				["Those Who Came Before You"] = "Search the body",
				["Of Course!"] = "Turn off the faucet",
			})
			did_action = advagain
			if result:contains("You close the valve") or result:contains("Go back to the Typical Tavern Cellar") then
				did_action = true
			end
		else
			inform "do guild, talk to bartender"
--~ 				local guildpt = get_page("/guild.php", { guild = "t" })
			local guildpt = get_page("/guild.php")
			if not guildpt:match("scg") then -- TODO: make sure this works and we pick up the stuff!
--~ 				posting page /guild.php params: Just [("action","chal")]
				-- check that we haven't unlocked anything
				-- TODO: make sure we actually win!
				post_page("/guild.php", { action = "chal" })
--~ got uri: /guild.php | ?place=ocg (from /guild.php?place=ocg), size 7458
			end
			get_page("/guild.php", { place = "ocg" })
			get_page("/guild.php", { place = "ocg" })
			get_page("/guild.php", { place = "scg" })
			get_page("/guild.php", { place = "scg" })
-- 				The Council says that the owner of the Typical Tavern, in the Distant Woods, is having some problems.
			-- TODO: pick up goofballs
			result, resulturl = get_page("/tavern.php", { place = "barkeep" })
			refresh_quest()
			if quest_text("Bart Ender wants you to head down") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_sewerlevel()
		if advs() < 20 then
			error("less than 20 advs for sewerleveling")
		elseif drunkenness() < 3 then
			error("no liver used when sewerleveling")
		else
			if not buff("Mental A-cue-ity") then -- TODO: support maybe_ensure_buffs or something, change this to use alice's voucher booze buff
				get_page("/clan_viplounge.php", { preaction = "poolgame", stance = "2" })
			end
			go("fight in sewer", 166, macro_noodlegeyser(3), {
				["Disgustin' Junction"] = "Swim back toward the entrance",
				["The Former or the Ladder"] = "Play in the water",
				["Somewhat Higher and Mostly Dry"] = "Dive back into the water",
			}, { "Springy Fusilli", "Spirit of Garlic", "Jaba&ntilde;ero Saucesphere" }, "Frumious Bandersnatch", 50, { equipment = { hat = "sugar chapeau" } })
			if did_action then
				wear {}
			end
		end
		return result, resulturl, did_action
	end

	function f.do_azazel()
		if not have("Azazel's lollipop") then
			if count("imp air") >= 5 and have("observational glasses") then
				inform("solve mourn, imp air: " .. count("imp air"))
				wear { weapon = "hilarious comedy prop", offhand = "Victor, the Insult Comic Hellhound Puppet", acc1 = "observational glasses" }
				result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "prop" })
				result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "insult" })
				wear {}
				if not have_inventory("hilarious comedy prop") or not have_inventory("Victor, the Insult Comic Hellhound Puppet") then
					error "Somehow didn't have items for Mourn!"
				end
				result, resulturl = post_page("/pandamonium.php", { action = "mourn", preaction = "observe" })
				if have("Azazel's lollipop") then
					did_action = true
				end
			else
				local macro_laughfloor = [[
if monstername imp
]] .. macro_ppnoodlecannon .. [[

  goto m_done
endif

]] .. macro_noodleserpent .. [[

mark m_done

]]
				go("mourn", 242, macro_laughfloor, nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 35)
			end
		elseif not have("Azazel's unicorn") then
			if count("bus pass") >= 5 and (count("sponge cake") + count("comfy pillow") + count("booze-soaked cherry")) >= 2 and (count("gin-soaked blotter paper") + count("giant marshmallow") + count("beer-scented teddy bear")) >= 2 then
				inform("solve sven golly, bus passes: " .. count("bus pass"))
				local bognort = have("giant marshmallow") and "giant marshmallow" or "gin-soaked blotter paper"
				local stinkface = have("beer-scented teddy bear") and "beer-scented teddy bear" or "gin-soaked blotter paper"
				local flargwurm = have("booze-soaked cherry") and "booze-soaked cherry" or "sponge cake"
				local jim = have("comfy pillow") and "comfy pillow" or "sponge cake"
				result, resulturl = post_page("/pandamonium.php", { action = "sven", preaction = "help" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Bognort", togive = get_itemid(bognort), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Stinkface", togive = get_itemid(stinkface), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Flargwurm", togive = get_itemid(flargwurm), preaction = "try" })
				result, resulturl = post_page("/pandamonium.php", { action = "sven", bandmember = "Jim", togive = get_itemid(jim), preaction = "try" })
				if have("Azazel's unicorn") then
					did_action = true
				end
			else
				go("sven golly", 243, macro_noodlecannon, nil, { "Leash of Linguini", "Empathy", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Slimeling", 20)
			end
		elseif not have("Azazel's tutu") then
			inform "solve stranger"
			result, resulturl = get_page("/pandamonium.php", { action = "moan" })
			result, resulturl = get_page("/pandamonium.php", { action = "moan" })
			if have("Azazel's tutu") then
				did_action = true
			end
		else
			inform "solve azazel"
			result, resulturl = get_page("/pandamonium.php", { action = "temp" })
			if have("steel margarita") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_boss_bat()
		local batholept = get_page("/bathole.php")
		-- TODO: Use a clover!
		if not batholept:match("Boss") then
			if have("sonar-in-a-biscuit") then
				use_item("sonar-in-a-biscuit")
				did_action = true
			else
				go("getting sonars", 31, macro_autoattack, nil, {"Leash of Linguini", "Empathy", "Fat Leon's Phat Loot Lyric"}, "Slimeling", 10)
			end
		else
			-- TODO: shrug phat and cast polka
			-- TODO: use organ grinder?
			set_mcd(4) -- TODO: moxie-specific
			local macro_bossbat = [[
]] .. COMMON_MACROSTUFF_START(20, 35) .. [[

if monstername bodyguard
  pickpocket
  cast Entangling Noodles

  if hasskill Static Shock
    cast Static Shock
  endif

  if hppercentbelow 75
    cast saucy salve
  endif

  while !times 10
    attack
  endwhile
  goto m_done
endif

cast Entangling Noodles

if hascombatitem rock band flyers
  use rock band flyers
endif

if hppercentbelow 75
  cast Saucy Salve
endif

while !times 3
  cast Cannelloni Cannon
endwhile

mark m_done

]]
			go("killing boss bat", 34, macro_noodlecannon, nil, { "Leash of Linguini", "Empathy" }, "Hobo Monkey", 25)
			set_mcd(10)
		end
		return result, resulturl, did_action
	end

	function f.make_meatcar()
		if not have("Degrassi Knoll shopping list") then
			inform "get shopping list"
			get_page("/guild.php", { place = "paco" })
			if have("Degrassi Knoll shopping list") then
				did_action = true
			else
				post_page("/guild.php", { action = "chal" })
				get_page("/guild.php", { place = "paco" })
				if have("Degrassi Knoll shopping list") then
					did_action = true
				end
			end
		else
			inform "build meatcar"
			get_page("/inventory.php", { quantity = 1, action = "makestuff", pwd = pwd, whichitem = get_itemid("meat stack"), ajax = 1 })
			buy_item("cog", "5")
			buy_item("empty meat tank", "5")
			buy_item("tires", "5")
			buy_item("spring", "5")
			buy_item("sprocket", "5")
			f.ensure_worthless_item()
			buy_item("hermit permit", "m")
			post_page("/hermit.php", { action = "trade", whichitem = get_itemid("sweet rims"), quantity = 1 })
			meatpaste_items("empty meat tank", "meat stack")
			meatpaste_items("spring", "sprocket")
			meatpaste_items("sprocket assembly", "cog")
			meatpaste_items("cog and sprocket assembly", "full meat tank")
			meatpaste_items("tires", "sweet rims")
			meatpaste_items("meat engine", "dope wheels")
			if not have("bitchin' meatcar") then
				error("Failed to build bitchin' meatcar")
			end
			inform "unlock beach"
			get_page("/forestvillage.php", { place = "untinker" })
			post_page("/forestvillage.php", { action = "screwquest" })
			get_page("/knoll.php", { place = "smith" })
			get_page("/forestvillage.php", { place = "untinker" })
			result, resulturl = get_page("/guild.php", { place = "paco" }) -- TODO: need the topmenu refreshed from this
			use_item("Degrassi Knoll shopping list")
			b = get_page("/beach.php")
			if b:match("shore.php") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.do_crypt()
		local cyrpt = get_page("/cyrpt.php")
		if have("skeleton bone") and have("loose teeth") then
			meatpaste_items("skeleton bone", "loose teeth")
		end
		if cyrpt:match("Defiled Nook") then
			local function get_crypt_zonedata()
				-- TODO: this is moxie-only
				if cyrpt:match("Defiled Niche") then
					return 57, {
						["Urning Your Keep"] = "Turn away",
						["Lich in the Niche"] = "Get his attention and throw down",
					}
				elseif cyrpt:match("Defiled Alcove") then
					return 56, {
						["Turn Your Head and Coffin"] = "Leave them all be",
						["Doublewide"] = "Open it up",
					}
				elseif cyrpt:match("Defiled Cranny") then
					return 55, {
						["Go Slow Past the Drawers"] = "Crawl inside the open one",
						["Lunchtime"] = "Try to take him by surprise",
					}
				elseif cyrpt:match("Defiled Nook") then
					return 54, {
						["Skull, Skull, Skull"] = "Check behind the first one",
						["Pileup"] = "Poke the pile",
					}
				end
			end
			local zoneid, noncombattbl = get_crypt_zonedata()
			go("do crypt quest", zoneid, macro_stasis(), noncombattbl, { "Butt-Rock Hair", "Smooth Movements", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds" }, "Rogue Program", 15)
		else
			inform "kill bonerdagon"
			ensure_buffs { "A Few Extra Pounds", "Jalape&ntilde;o Saucesphere", "Jaba&ntilde;ero Saucesphere", "Springy Fusilli", "Spirit of Garlic" }
			fam "Knob Goblin Organ Grinder"
			f.heal_up()
			ensure_mp(50)
			local pt, url = get_page("/cyrpt.php", { action = "haert" })
			result, resulturl, advagain = handle_adventure_result(pt, url, "?", macro_noodlegeyser(7))
			if advagain then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.get_ballroom_key()
		local manor = get_page("/manor.php")
		if not manor:match("Stairs Up") then
			go("unlock upstairs", 104, macro_stasis(), {}, {"Smooth Movements", "The Sonata of Sneakiness", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 5, { choice_function = function (advtitle, choicenum)
				if advtitle == "Take a Look, it's in a Book!" then
					return "", 99
				end
			end})
		else
			local toequip = {}
			if get_mainstat() == "Muscle" then
				if have("Crown of the Goblin King") then
					toequip = { hat = "Crown of the Goblin King" }
				end
				wear(toequip)
				get_page("/charpane.php") -- HACK: Workaround for CDM bug
				if buffedmainstat() < 85 then
					ensure_buffs{"Go Get 'Em, Tiger!"}
					get_page("/charpane.php") -- HACK: Workaround for CDM bug
				end
			elseif get_mainstat() == "Mysticality" then
				wear {}
				if buffedmainstat() < 85 then
					ensure_buffs{"Glittering Eyelashes"}
					get_page("/charpane.php") -- HACK: Workaround for CDM bug
				end
				if buffedmainstat() < 85 and not buff("Smoky Third Eye") and not buff("Down the Rabbit Hole") and have("&quot;DRINK ME&quot; potion") then
					if not have("ravioli hat") then
						return f.buy_use_chewing_gum()
					end
					use_item("&quot;DRINK ME&quot; potion")
					wear { hat = "ravioli hat" }
					get_page("/rabbithole.php", { action = "teaparty" })
					post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get hatter buff
					wear {}
					get_page("/charpane.php") -- HACK: Workaround for CDM bug
				end
			elseif get_mainstat() == "Moxie" then
				wear {}
				if buffedmainstat() < 85 then
					ensure_buffs{"Butt-Rock Hair"}
					get_page("/charpane.php") -- HACK: Workaround for CDM bug
				end
				if buffedmainstat() < 85 and not buff("Cat-Alyzed") and not buff("Down the Rabbit Hole") and have("&quot;DRINK ME&quot; potion") then
					use_item("&quot;DRINK ME&quot; potion")
					wear { hat = "snorkel" }
					get_page("/rabbithole.php", { action = "teaparty" })
					post_page("/choice.php", { pwd = pwd, whichchoice = "441", option = "1" }) -- get hatter buff
					wear {}
					get_page("/charpane.php") -- HACK: Workaround for CDM bug
				end
			end
			if buffedmainstat() < 85 and not buff("Starry-Eyed") then
				local gazept = post_page("/campground.php", { action = "telescopehigh" })
				get_page("/charpane.php") -- HACK: Workaround for CDM bug
			end
			if buffedmainstat() < 85 then
				error("Can't enter bedroom")
			end
			if not buff("Mental A-cue-ity") then -- TODO: support maybe_ensure_buffs or something
				get_page("/clan_viplounge.php", { preaction = "poolgame", stance = "2" })
			end
			go("do bedroom", 108, macro_noodlegeyser(4), {}, { "Smooth Movements", "The Sonata of Sneakiness", "Springy Fusilli", "Spirit of Garlic", "Jaba&ntilde;ero Saucesphere", "Jalape&ntilde;o Saucesphere" }, "Frumious Bandersnatch", 50, { choice_function = function (advtitle, choicenum)
				if choicenum == 82 then
					return "Kick it and see what happens"
				elseif choicenum == 83 then
					return "Check the bottom drawer"
				elseif choicenum == 84 then
					if have("Lord Spookyraven's spectacles") then
						return "Open the bottom drawer"
					else
						return "Look behind the nightstand"
					end
				elseif choicenum == 85 then
					print("bedroom key adventure", ascension["zone.manor.unlocked ballroom key"], ascension["scriptcheck.done ballroom key"])
					if not ascension["zone.manor.unlocked ballroom key"] and not ascension["scriptcheck.done ballroom key"] then
						ascension["scriptcheck.done ballroom key"] = "yes"
						return "Check the top drawer"
					else
						return "Check the bottom drawer"
					end
				end
			end, equipment = toequip })
		end
		return result, resulturl, did_action
	end

	function f.do_friars()
-- 		TODO: more buffs?
		if not have("eldritch butterknife") then
			go("get butterknife", 237, macro_stasis(), nil, {"Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 15)
		elseif not have("box of birthday candles") then
			go("get candles", 238, macro_stasis(), nil, {"Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "A Few Extra Pounds"}, "Rogue Program", 15)
		elseif not have("dodecagram") or not have("ruby W") or have_reagent_pastas < 4 then
			go("get dodecagram", 239, make_cannonsniff_macro("Hellion"), nil, {"Astral Shell", "Ghostly Shell", "Leash of Linguini", "Empathy", "Butt-Rock Hair", "Spirit of Garlic", "Fat Leon's Phat Loot Lyric", "A Few Extra Pounds"}, "Slimeling", 20, { olfact = "Hellion" })
		else
			if count("hot wing") < 3 then
				error "Not enough hot wings!" -- TODO: handle
			end
			inform "do ritual"
			post_page("/friars.php", { pwd = pwd, action = "ritual" })
			post_page("/friars.php", { pwd = pwd, action = "buffs", bro = "1" })
			local pandapt = get_page("/pandamonium.php")
			refresh_quest()
			if not quest("Trial By Friar") and quest_text("this is Azazel in Hell") then
				did_action = true
			end
		end
		return result, resulturl, did_action
	end

	function f.get_library_key()
		local townright = get_page("/town_right.php")
		if townright:match("The Haunted Pantry") then
			go("unlock manor", 113, macro_stasis(), {
				["Oh No, Hobo"] = "Give him a beating",
				["Trespasser"] = "Tackle him",
				["The Singing Tree"] = "&quot;No singing, thanks.&quot;",
				["The Baker's Dilemma"] = "&quot;Sorry, I'm busy right now.&quot;",
			}, {}, "Mini-Hipster", 5)
			if result:match("The Manor in Which You're Accustomed") then
				did_action = true
			end
		else
			local manor = get_page("/manor.php")
			if manor:match("Stairs Up") then
				get_page("/manor.php", { place = "stairs" })
				did_action = true
			else
				if have("pool cue") and have("handful of hand chalk") and not buff("Chalky Hand") then
					use_item("handful of hand chalk")
				end
-- 					TODO: act differently if you can't win?
				go("unlock library", 105, macro_stasis(), {
					["Minnesota Incorporeals"] = "Let the ghost break",
					["Broken"] = "Go for a solid",
					["A Hustle Here, a Hustle There"] = "Go for the 8-ball",
				}, {"Smooth Movements", "The Sonata of Sneakiness"}, "Stocking Mimic", 5)
			end
		end
		return result, resulturl, did_action
	end

	function f.get_dod_wand()
		-- TODO: don't get teleportitis that overlaps with SR
		-- do meatcar/beach/shore
		local dungeons = get_page("/dungeons.php")
		if dungeons:match("The Enormous Greater%-Than Sign") then
			if advs() < 20 then
				error("less than 20 advs for > sign")
			elseif meat() < 1000 then
				error("need 1k meat for > sign")
			elseif have("plus sign") and buff("Teleportitis") then
				fam "Frumious Bandersnatch"
				ensure_buffs { "Ode to Booze" }
				inform "TODO: find oracle, then do DD to wear off teleportitis, shore once"
			else
				go("unlock dod", 226, macro_noodlecannon, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic" }, "Slimeling", 25, { choice_function = function (advtitle, choicenum)
					if advtitle == "Typographical Clutter" then
						if not have("plus sign") then
							return "The big apostrophe"
						else
							return "The upper-case Q"
						end
					end
				end })
			end
		else
			if have("dead mimic") then
				use_item("dead mimic")
				if have("pine wand") or have("ebony wand") or have("hexagonal wand") or have("aluminum wand") or have("marble wand") then
					did_action = true
				end
			elseif meat() < 5000 then
				error("need 5k meat for DoD wand")
			else
				go("get dod wand", 39, macro_noodlecannon, {
					["Ouch!  You bump into a door!"] = "Buy what appears to be some sort of cloak (5,000 Meat)",
				}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Leash of Linguini", "Empathy" }, "Slimeling", 20)
			end
		end
		return result, resulturl, did_action
	end

	-- TODO: merge with unlock_hits
	function f.do_castle()
		-- TODO: buff +item% more
		go("do castle in the sky", 82, macro_noodleserpent, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Butt-Rock Hair" }, "Slimeling", 40, { choice_function = function (advtitle, choicenum)
			if advtitle == "Wheel in the Clouds in the Sky, Keep On Turning" then
				if choicenum == 9 and get_mainstat() ~= "Mysticality" then
					return "Turn the wheel counterclockwise"
				elseif choicenum == 12 then
					return "Turn the wheel counterclockwise"
				elseif choicenum == 11 then
					return "Leave the wheel alone"
				elseif choicenum == 9 and get_mainstat() == "Mysticality" then
					return "Turn the wheel clockwise"
				elseif choicenum == 10 then
					return "Turn the wheel clockwise"
				end
			end
		end})
	end

	function f.unlock_hits()
		result, resulturl = use_item("giant castle map")
		if have("quantum egg") then
			inform "make rowboat"
			meatpaste_items("S.O.C.K.", "quantum egg")
			if have("intragalactic rowboat") then
				did_action = true
			end
		elseif result:contains("have to figure out some way to get the guard away from the door") then
			go("unlock hits", 82, macro_noodleserpent, {}, { "Smooth Movements", "The Sonata of Sneakiness", "Fat Leon's Phat Loot Lyric", "Spirit of Garlic", "Butt-Rock Hair" }, "Slimeling", 40, { choice_function = function (advtitle, choicenum)
				if advtitle == "Wheel in the Clouds in the Sky, Keep On Turning" then
					if choicenum == 9 and get_mainstat() ~= "Mysticality" then
						return "Turn the wheel counterclockwise"
					elseif choicenum == 12 then
						return "Turn the wheel counterclockwise"
					elseif choicenum == 11 then
					elseif choicenum == 9 and get_mainstat() == "Mysticality" then
						return "Turn the wheel clockwise"
					elseif choicenum == 10 then
						return "Turn the wheel clockwise"
					end
				end
			end})
		end
	end

	return f
end
